package com.rjconsultores.ventaboletos.web.gui.controladores.seguridad;

import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Controller;
import org.zkoss.util.resource.Labels;
import org.zkoss.zhtml.Messagebox;
import org.zkoss.zk.ui.Component;
import org.zkoss.zk.ui.Executions;
import org.zkoss.zk.ui.event.Event;
import org.zkoss.zul.Textbox;

import com.rjconsultores.ventaboletos.entidad.Perfil;
import com.rjconsultores.ventaboletos.entidad.Pricing;
import com.rjconsultores.ventaboletos.service.PerfilService;
import com.rjconsultores.ventaboletos.service.PricingService;
import com.rjconsultores.ventaboletos.web.utilerias.MyGenericForwardComposer;
import com.rjconsultores.ventaboletos.web.utilerias.MyListbox;

@Controller("copiarPerfilController")
@Scope("prototype")
public class CopiarPerfilController extends MyGenericForwardComposer {

	private static final long serialVersionUID = 1L;

	@Autowired
	private PricingService pricingService;
	@Autowired
	private PerfilService perfilService;

	private Textbox nombrePricing;
	private Pricing pricing;

	private Textbox nombrePerfil;
	private Perfil perfil;

	@Override
	public void doAfterCompose(Component comp) throws Exception {
		perfil = (Perfil) Executions.getCurrent().getArg().get("perfil");

		super.doAfterCompose(comp);
	}

	public void onClick$btnSalvarCopia(Event ev) throws InterruptedException {
		if (!nombrePerfil.getText().equals("") && nombrePerfil.getText() != null) {

			List<Perfil> lsPerfil =
					perfilService.buscar(nombrePerfil.getText());

			if (lsPerfil.isEmpty()) {

				Boolean resp = perfilService.clonarPerfil(perfil.getPerfilId(), nombrePerfil.getText());

				if (resp) {

					closeWindow();
					Messagebox.show(
							Labels.getLabel("copiarPerfilController.MSG.suscribirOK"),
							Labels.getLabel("copiarPerfilController.window.title"),
							Messagebox.OK, Messagebox.INFORMATION);

				} else {
					Messagebox.show(
							Labels.getLabel("copiarPerfilController.MSG.ERRO"),
							Labels.getLabel("copiarPerfilController.window.title"),
							Messagebox.OK, Messagebox.INFORMATION);
				}

			} else {
				Messagebox.show(
						Labels.getLabel("copiarPerfilController.MSG.Registro.Existe"),
						Labels.getLabel("copiarPerfilController.window.title"),
						Messagebox.OK, Messagebox.EXCLAMATION);
			}
		} else {
			Messagebox.show(
					Labels.getLabel("copiarPerfilController.MSG.sem.nome"),
					Labels.getLabel("copiarPerfilController.window.title"),
					Messagebox.OK, Messagebox.EXCLAMATION);
		}
	}

	public void onClose$winCopiarPricing(Event ev) {
		closeWindow();
	}

}
